#include <stdio.h>
#include <string.h>
#include "fdsprg.h"

#define ARGVERR puts("NSFPFDS [/f filename.fds] file1.nsf file2.nsf ...");return -1;

int main(int argv,char *args[])
{
	FILE *fnsf;
	FILE *ffds;
	unsigned char fdsname[400]="";
	unsigned char nsf[NSFSIZEMAX + 0x80];
	unsigned char hbf[0x11]={0x03,0xff,0xff,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
							,0x00,0x00,0xff,0xff,0x00,0x04};
	char arg=1;
	int a,b,nsfsize,ald,ain,apl,fdsp,fnum;

	puts("NSF to NSF Player FDS Converter\n2013/04/12 by OffGao\n");
	if(argv<2){
		ARGVERR;
	}
	
	//FDS̃t@Cw肳ĂH
	if(!strcmp(args[arg],"/f")||!strcmp(args[arg],"/F")){
		if(argv<4){
			ARGVERR;
		}else{
			arg++;
			strcpy(fdsname,args[arg]);
			arg++;
		}
	}

	//NSFt@Cǂ
	fdsp=PRGFOOT;
	fnum=FIRSTFILENUM;
	puts("\n[NSF READ]");
	for(a=0;a<8&&arg<argv;arg++){
		fnsf = fopen(args[arg],"rb");
		if(fnsf==NULL){
			printf("%s : open error\n",args[arg]);
		}else{
			fseek(fnsf,0,SEEK_END);
			nsfsize = ftell(fnsf);
			if(NSFSIZEMAX + 0x80 < nsfsize){
				printf("%s : size over\n",args[arg]);
				fclose(fnsf);
			}else{
				fseek(fnsf,0,SEEK_SET);
				fread(nsf,1,nsfsize,fnsf);
				fclose(fnsf);
				if(nsf[0x70]||nsf[0x71]||nsf[0x72]||nsf[0x73]||nsf[0x74]||nsf[0x75]||nsf[0x76]||nsf[0x77]){
					printf("%s : unsupport bank\n",args[arg]);
				}else{
					ald=nsf[0x08]+nsf[0x09]*256;
					ain=nsf[0x0a]+nsf[0x0b]*256;
					apl=nsf[0x0c]+nsf[0x0d]*256;
					b = ald + nsfsize - 0x80;
					if(b >= 0xde00){
						printf("%s : address over DE00-\n",args[arg]);
					}else if(ald < 0x6000){
						printf("%s : address over -5FFF\n",args[arg]);
					}else{
						nsfsize -= 0x80;
						//if(b >= 0xdffa){
						//	nsfsize -= b - 0xdff9;
						//}
						if(fdsp+0x11+nsfsize+0x11+sizeof(fdsi)+0x11+7>sizeof(fds)){
							printf("%s : fds size over\n",args[arg]);
						}else{
							//NSFt@Cu
							hbf[0x1]=fnum;fnum++;
							hbf[0x2]=a+0x10;
							hbf[0x3]='N';hbf[0x4]='S';hbf[0x5]='F';hbf[0x6]='P';
							hbf[0x7]='R';hbf[0x8]='G';hbf[0x9]='_';hbf[0xa]='1'+a;
							hbf[0xb]=nsf[0x08];
							hbf[0xc]=nsf[0x09];
							hbf[0xd]=nsfsize&0xff;
							hbf[0xe]=(nsfsize>>8)&0xff;
							hbf[0xf]=0;
							memcpy(fds+fdsp,hbf,0x11);
							fdsp+=0x11;
							memcpy(fds+fdsp,nsf+0x80,nsfsize);
							fdsp+=nsfsize;

							//NSFu
							hbf[0x1]=fnum;fnum++;
							hbf[0x2]=a+0x10;
							hbf[0x3]='N';hbf[0x4]='S';hbf[0x5]='F';hbf[0x6]='C';
							hbf[0x7]='H';hbf[0x8]='R';hbf[0x9]='_';hbf[0xa]='1'+a;
							hbf[0xb]=0x82;
							hbf[0xc]=0x22;
							hbf[0xd]=sizeof(fdsi);
							hbf[0xe]=0;
							hbf[0xf]=2;
							memcpy(fds+fdsp,hbf,0x11);
							fdsp+=0x11;
							for(b=0;b<3;b++)
								memcpy(fdsi+b*NSFINFOM,nsf+0x0e+b*0x20,FDSINFOSTR);
							memcpy(fds+fdsp,fdsi,sizeof(fdsi));
							fdsp+=sizeof(fdsi);

							//NSFu
							hbf[0x1]=fnum;fnum++;
							hbf[0x2]=a+0x10;
							hbf[0x3]='N';hbf[0x4]='S';hbf[0x5]='F';hbf[0x6]='A';
							hbf[0x7]='D';hbf[0x8]='R';hbf[0x9]='_';hbf[0xa]='1'+a;
							hbf[0xb]=0x00;
							hbf[0xc]=NSFADR;
							hbf[0xd]=0x07;
							hbf[0xe]=0x00;
							hbf[0xf]=0;
							memcpy(fds+fdsp,hbf,0x11);
							fdsp+=0x11;
							fds[fdsp++]=nsf[0x06];
							fds[fdsp++]=0x4c;
							fds[fdsp++]=nsf[0x0a];
							fds[fdsp++]=nsf[0x0b];
							fds[fdsp++]=0x60;
							fds[fdsp++]=nsf[0x0c];
							fds[fdsp++]=nsf[0x0d];

							//NSFXgɓ
							memcpy(fds+NSFLIST+a*NSFLISTM,nsf+0x0e,FDSLISTSTR);

							printf("%s : OK\n",args[arg]);
							a++;
						}
					}
				}
			}
		}
	}
	fds[FILENO] = fnum;
	if(a>0){
		puts("\n[FDS WRITE]");
		if(fdsname[0]==0){
			strcpy(fdsname,args[0]);
			for(a=sizeof(fdsname)-3;a>0;a--){
				if((fdsname[a+0]=='E'||fdsname[a+0]=='e')
				 &&(fdsname[a+1]=='X'||fdsname[a+1]=='x')
				 &&(fdsname[a+2]=='E'||fdsname[a+2]=='e'))break;
			}
			if(a>0){
				fdsname[a+0]='f';
				fdsname[a+1]='d';
				fdsname[a+2]='s';
			}else{
				strcpy(fdsname,"nsfpfds.fds");
			}
		}
		ffds = fopen(fdsname,"wb");
		if(ffds==NULL){
			printf("%s : open error\n",fdsname);
			return -1;
		}else{
			fwrite(fds,1,sizeof(fds),ffds);
			fclose(ffds);
			printf("%s : OK\n",fdsname);
		}
	}
	return 0;
}